/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.wahlbeteiligung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="WAHLBETEILIGUNG_VERLAUF.UK",
     query="SELECT o FROM WahlbeteiligungVerlauf o WHERE "

                         + "o"
                +".datum"
              +" = ?1"

             +" AND "         + "o"
                +".name"
              +" = ?2"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?5"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?6"

             +" AND "         + "o"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?7"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="WAHLBETEILIGUNG_VERLAUF.Wahl",
     query="SELECT o FROM WahlbeteiligungVerlauf o WHERE o.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "WAHLBETEILIGUNG_VERLAUF")
// @javax.persistence.IdClass(WahlbeteiligungVerlaufPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class WahlbeteiligungVerlauf
extends AbstractWahlbeteiligungVerlauf
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public WahlbeteiligungVerlauf() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public WahlbeteiligungVerlauf(WahlbeteiligungVerlauf original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "wahlbeteiligung_verlauf_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "WahlbeteiligungVerlauf")
    @javax.persistence.TableGenerator(name = "WahlbeteiligungVerlauf", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "WahlbeteiligungVerlauf", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient WahlbeteiligungVerlaufPK pkCache;

  @Override
  public WahlbeteiligungVerlaufPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new WahlbeteiligungVerlaufPK(getId());
    }

    return pkCache;
  }

  public static <E extends WahlbeteiligungVerlauf> java.util.Map<WahlbeteiligungVerlaufPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<WahlbeteiligungVerlaufPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends WahlbeteiligungVerlauf> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBemerkung = false;
          hasChangedDatum = false;
          hasChangedName = false;
          hasChangedStatus = false;
          hasChangedTyp = false;
  
      hasChangedWahl = false;
  

          hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEMERKUNG", nullable = WahlbeteiligungVerlaufConstants.BEMERKUNG_NULLABLE, length=WahlbeteiligungVerlaufConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for WAHLBETEILIGUNG_VERLAUF.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for WAHLBETEILIGUNG_VERLAUF.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, WahlbeteiligungVerlaufConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "DATUM", nullable = WahlbeteiligungVerlaufConstants.DATUM_NULLABLE, precision=WahlbeteiligungVerlaufConstants.DATUM_PRECISION)
    
  protected java.util.Date datum =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDatum = false;

  public boolean hasChangedDatum(){
    return hasChangedDatum;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDatum = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenDatum;
  
  /**
   * 
   *
   * getter for WAHLBETEILIGUNG_VERLAUF.DATUM
   */
    @Override   public  java.util.Date getDatum() {
              if (datum == null){
            return null;
          } else {
                          return datum;
          }
      }

  /**
   * 
   *
   * setter for WAHLBETEILIGUNG_VERLAUF.DATUM
   *
   * @param datum
   */
  @Override   public void setDatum( java.util.Date datum) {

       resetTkCache();
                  java.util.Date datumInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(datum);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datum
      , datumInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDatum |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("datum");
      }


             if (!isSeitLadenVeraendertDatum) {
          isSeitLadenVeraendertDatum = thisAttributChanged;
         if (isSeitLadenVeraendertDatum){
           wertNachLadenDatum=this.datum;
         }
       }
      

       this.datum = datumInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = WahlbeteiligungVerlaufConstants.NAME_NULLABLE, length=WahlbeteiligungVerlaufConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for WAHLBETEILIGUNG_VERLAUF.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for WAHLBETEILIGUNG_VERLAUF.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, WahlbeteiligungVerlaufConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = WahlbeteiligungVerlaufConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufStatus status =  null;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertStatus = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufStatus wertNachLadenStatus;
  
  /**
   * 
   *
   * getter for WAHLBETEILIGUNG_VERLAUF.STATUS
   */
    @Override   public  de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufStatus getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for WAHLBETEILIGUNG_VERLAUF.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufStatus status) {

       resetTkCache();
                  de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufStatus statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


             if (!isSeitLadenVeraendertStatus) {
          isSeitLadenVeraendertStatus = thisAttributChanged;
         if (isSeitLadenVeraendertStatus){
           wertNachLadenStatus=this.status;
         }
       }
      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "TYP", nullable = WahlbeteiligungVerlaufConstants.TYP_NULLABLE)
    
  protected de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufTyp typ =  null;

  @javax.persistence.Transient
  protected boolean hasChangedTyp = false;

  public boolean hasChangedTyp(){
    return hasChangedTyp;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertTyp = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufTyp wertNachLadenTyp;
  
  /**
   * 
   *
   * getter for WAHLBETEILIGUNG_VERLAUF.TYP
   */
    @Override   public  de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufTyp getTyp() {
        return typ;
      }

  /**
   * 
   *
   * setter for WAHLBETEILIGUNG_VERLAUF.TYP
   *
   * @param typ
   */
  @Override   public void setTyp( de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufTyp typ) {

       resetTkCache();
                  de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufTyp typInternal = typ;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.typ
      , typInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("typ");
      }


             if (!isSeitLadenVeraendertTyp) {
          isSeitLadenVeraendertTyp = thisAttributChanged;
         if (isSeitLadenVeraendertTyp){
           wertNachLadenTyp=this.typ;
         }
       }
      

       this.typ = typInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl( de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu WahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet.class, mappedBy="wahlbeteiligungVerlauf", fetch=javax.persistence.FetchType.LAZY )
// elect-deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet> wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet> getWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf(){
    if (wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf == null){
      return  java.util.Collections.<de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet>unmodifiableSet(this.wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf);
  }

  @javax.persistence.Transient
  private boolean hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf = false;

  public boolean hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf() {
    return hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet
   */
  @Override
  public void addWahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf != null){
          if (this.wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf == null) {
            this.wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf = new java.util.HashSet<>();
          }

          boolean isChanged = this.wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf.add(wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf);

          if(!hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf) {
            hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf.setWahlbeteiligungVerlauf(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet
   */
  @Override
  public void removeWahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf(de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf != null){
          if (this.wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf != null) {
            boolean isChanged = this.wahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf.remove(wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf);

            if(!hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf) {
              hasChangedWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          wahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf.setWahlbeteiligungVerlauf(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet
  */
   @Override
   public void removeAllWahlbeteiligungVerlaufGebietByWahlbeteiligungVerlaufs(){
     java.util.Set<de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet> toRemove = new java.util.HashSet<>(getWahlbeteiligungVerlaufGebietsByWahlbeteiligungVerlauf());

     for (   de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufGebiet entity:toRemove){
       removeWahlbeteiligungVerlaufGebietByWahlbeteiligungVerlauf(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("WahlbeteiligungVerlauf:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(WahlbeteiligungVerlauf other){
                             other.bemerkung = this.bemerkung;
                                other.datum = this.datum;
                                other.name = this.name;
                                other.status = this.status;
                                other.typ = this.typ;
           
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(WahlbeteiligungVerlauf.class)){
        copyEntityAttributesUsingSetter((WahlbeteiligungVerlauf) other.castTo(WahlbeteiligungVerlauf.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von WahlbeteiligungVerlauf: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(WahlbeteiligungVerlauf other){
               other.setBemerkung(this.bemerkung);
                  other.setDatum(this.datum);
                  other.setName(this.name);
                  other.setStatus(this.status);
                  other.setTyp(this.typ);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(WahlbeteiligungVerlauf other){
                       if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedDatum) {
        other.setDatum(this.datum);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedTyp) {
        other.setTyp(this.typ);
      }
             }





    @javax.persistence.Transient
    private transient WahlbeteiligungVerlaufTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public WahlbeteiligungVerlaufTK getWahlbeteiligungVerlaufTK(){
    if (tkCache==null) {
    tkCache = new WahlbeteiligungVerlaufTK(

getDatum()
, getName()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getWahlbeteiligungVerlaufTK();
    }

  @Override
  public WahlbeteiligungVerlaufUK getUk(){
    return getWahlbeteiligungVerlaufUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return WahlbeteiligungVerlauf.class;
  }

public WahlbeteiligungVerlaufUK getWahlbeteiligungVerlaufUK(){

   return  new WahlbeteiligungVerlaufUK(

getDatum()
, getName()
,     getWahl()==null?null:getWahl().getWahlUK()


  );
}

  @javax.persistence.Transient
  private transient WahlbeteiligungVerlaufProperties properties;

  public WahlbeteiligungVerlaufProperties getProperties(){
    if (properties == null) {
      properties = new WahlbeteiligungVerlaufProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public WahlbeteiligungVerlaufProperties getWahlbeteiligungVerlaufProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return WahlbeteiligungVerlaufConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_DATUM_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_DATUM_EINZAHL);

        datum =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_STATUS_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_STATUS_EINZAHL);

        status =
     (de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufStatus) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_TYP_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_TYP_EINZAHL);

        typ =
     (de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungVerlaufTyp) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBemerkung) {
      result.put(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertDatum) {
      result.put(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_DATUM_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.TIMESTAMP
                , wertNachLadenDatum , datum));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                            if (isSeitLadenVeraendertStatus) {
      result.put(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_STATUS_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenStatus , status));
    }
                            if (isSeitLadenVeraendertTyp) {
      result.put(WahlbeteiligungVerlaufConstants.MESSAGE_KEY_TYP_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenTyp , typ));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertDatum = false;
      wertNachLadenDatum = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                          isSeitLadenVeraendertStatus = false;
      wertNachLadenStatus = null;
                          isSeitLadenVeraendertTyp = false;
      wertNachLadenTyp = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "WAHLBETEILIGUNG_VERLAUF";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "WahlbeteiligungVerlauf";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlbeteiligungVerlaufConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, WahlbeteiligungVerlaufConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(datum, this, WahlbeteiligungVerlaufConstants.MESSAGE_KEY_DATUM_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, WahlbeteiligungVerlaufConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(WahlbeteiligungVerlaufConstants.NAME_MAX_LENGTH , 1 ,  name, this, WahlbeteiligungVerlaufConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, WahlbeteiligungVerlaufConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(typ, this, WahlbeteiligungVerlaufConstants.MESSAGE_KEY_TYP_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
